#include <stdio.h>
#include <wiringPi.h>
#include <wiringPiSPI.h>

#define MCP4922Channel  0	// MCP4922のISPチャネル
#define BUF		0	// Vrefバッファなし
#define GA		1	// 出力バッファ1倍

//   MCP4922 制御関数
//   dac(int ch, int data)
//   ch   : 0ならDAC_A, 1ならDAC_B
//   data : 0x000-0xfffまでの整数。
//   #define でMCP4922Channel, BUF, GAを定義しておくこと
dac(int ch, int data) {
    unsigned char high = 0;
    unsigned char low = 0;
    unsigned char buf[2];

    if (ch==1)  high |= 0x80;	// DAC_AまたはDAC_Bの指定
    if (BUF==1) high |= 0x40;   // Vref入力バッファ制御ビットの設定
    if (GA==1)  high |= 0x20;	// 出力アンプ利得制御ビットの設定
    high |= 0x10;		// パワーダウンしない（固定)

    high |= (data & 0xf00) >> 8;
    low  =  (data & 0x0ff);

    buf[0] = high;
    buf[1] = low;

    wiringPiSPIDataRW(MCP4922Channel, buf, 2);
}

main() {
    int i;

    wiringPiSetup();
    wiringPiSPISetupMode(MCP4922Channel, 10000000, 0);	// SPI 10MBPS Mode0

    for(;;) {
	for(i=0; i<4096; i++) {
	    dac(0, i);
	    dac(1, 4095-i);
	    delayMicroseconds(100);
        }
    }
}

